<%--
 * Component: tools
 *
 *    Shows selected data on the graph
 *
--%><%@
	page import="
			java.io.*,java.util.*,java.text.*, java.nio.file.*,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			imagemed.imsession.*,
			imagemed.util.Helper"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

String f[][]={
{"Dicom objects acquired (<font color=red>new</font>, <font color=green>resent</font>)",
   "acquisitions", null, "dicom_acquired_new", "dicom_acquired_old"},
{"Dicom objects forwarded (<font color=red>forwarded</font>, <font color=green>archived</font>)",
   "forwards", null, "obj_forwarded","obj_archived"},
null,
{"Objects processed (<font color=red>acquired</font>, <font color=green>retrieved</font>, <font color=blue>reindexed</font>)",
   "objects",null,"obj_acquired","obj_retrieved","obj_reindexed"},
{"Processing latency (sec)",
   "obj_processing_latency"},
{"Objects in queue",
   "obj_processing_behind"},
null,
{"Images served (Mbytes/min) (<font color=red>raw</font>,<font color=green>compressed</font>)",
  "served",null, "bytes_served_raw", "bytes_served_cmp"},
{"Images max throughput (Mbits/sec) (<font color=red>raw</font>,<font color=green>compressed</font>)",
  "served_max",null, "bytes_served_max_raw", "bytes_served_max_cmp"},
null,
{"Processor load (1 min) ", "proc_load0"},
{"Processor load (5 min) ", "proc_load1"},
{"Processor load (15 min)", "proc_load2"},
null,
{"# sleeping processes","number_of_sleeping_proc",""},
{"# running processes" ,"number_of_running_proc",""},
{"# zombie processes"  ,"number_of_zombie_proc",""},
null,
{"CPU usage %","proc_cpu","100"},
{"IO wait %","proc_iowait","100"},
{"CPU idle %","proc_idle","100"},
null,
{"Memory usage","proc_mem"},
{"Memory usage actual","proc_mem_actual"},
null,
{"Data partition usage %","percent_of_used_disk_on_data_partition"},
{"TMP partition usage %","percent_of_used_disk_on_tmp_partition"},
null,
{"Time of SQL query (s)","sql_query"},
{"Time of WL page download (s)","page_downloading"},
/*
null,
{"CPU queue scheduled","taskd_cpu_s_counter"},
{"CPU queue retry","taskd_cpu_r_counter"},
{"CPU queue failed","taskd_cpu_f_counter"},
null,
{"CPU queue critical lag","taskd_cpu_s_largest_critical_lag"},
{"CPU queue total lag","taskd_cpu_s_largest_noncritical_lag"},
*/
null,
{"Task queue (<font color=red>retry</font>, <font color=green>scheduled</font>)",
  "taskd", null, "taskd_net_r_counter","taskd_net_s_counter"},
{"Task queue failed","taskd_net_f_counter"},
null,
{"Task queue critical lag","taskd_net_s_largest_critical_lag"},
{"Task queue total lag","taskd_net_s_largest_noncritical_lag"},
null,
{"DICOM associations %", "dicom_proc"},
{"Apache threads %", "apache_proc"},
{"Tomcat threads %", "tomcat_proc"}
};

Properties ps = new Properties();
Properties pp = new Properties();

{
	for (int i=0;i<f.length;i++)
	{
		if ( f[i]!=null && f[i][0]!=null && f[i][1]!=null)
		    ps.setProperty(f[i][1],Integer.toString(i));
	}

	String dir = IMEnvBase.getEnv("TOOLS_HOME")+"/stat";
	
	try (DirectoryStream<Path> ds = Helper.getDirectoryStream( dir )) {
		if ( ds != null ) {
			for ( Path path : ds ) {
				Path fileNamePath = path.getFileName();
				if(fileNamePath == null){
					continue;
				}
				String fn=fileNamePath.toString();
				if(fn.startsWith("post_") && fn.endsWith(".sh"))
				{
					String pn = path.toString();
					String[] cmd = {pn,"-p"};
					String pr= Helper.runCommand(cmd,null);
					String prps[] = pr.split("\n");
					for (int j=0;j<prps.length; j++)
					{
						pp.setProperty(prps[j],fn.substring(5,fn.length()-3));
						Helper.DEBUG( "property set:" + prps[j] + " to " + fn.substring(5,fn.length()-3) );
					}
				}
			}
		}
	}catch(IOException ioe){
		//if automatic close was not successful
	}
}



%><!DOCTYPE html>
<HTML>
<HEAD><TITLE>Monitor</TITLE>
<%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	imagemed.http.tabs.TabBean.writeStyleOnly( response.getWriter() );
%>
</HEAD>
<BODY>
<%

	String parDate=request.getParameter("cDate");
	boolean parReload=(request.getParameter("cReload")!=null);

	String parDataArray[] = request.getParameterValues("cData");
	if (parDataArray!=null)
		for (int i=0; i<parDataArray.length; i++)
		{
			String s=parDataArray[i];
			String ss=s;
			int ii=-1;
			String iis=ps.getProperty(s);
			if (iis!=null)
			{
				ii = Integer.parseInt(iis);
				ss=f[ii][0];
			}
			out.println("<center><font size=+2>"+ss+"</font></center>");
			
			String pr=pp.getProperty(f[ii].length>=4? f[ii][3] : s);
			String csvData="";

			LinkedList<String> cmd = new LinkedList<String>();
			cmd.add( IMEnvBase.getEnv( "TOOLS_HOME" ) + "/stat/makegraph0.sh" );
			cmd.add( "-d" );
			cmd.add( parDate );
			cmd.add( "-f" );
			cmd.add( s );
			cmd.add( "-p" );
			cmd.add( pr );
			if ( parReload ) {
				cmd.add( "-r" );
			}
			
			if (ii>=0 && f[ii].length>=4)
			{
				for (int j=3;j<f[ii].length; j++)
				{
					cmd.add( f[ii][j] );
					csvData+="&cData="+f[ii][j];
				}
			}
			else
			{
				cmd.add( s );
				csvData+="&cData="+s;
			}
			
			out.println("Max: " + Helper.runCommand( cmd.toArray( new String[ cmd.size() ] ) ,null ) );
			out.println("<A href=\"getcsv.jsp?cName="+s+"&cDate="+parDate+"&cProc="+pr+csvData+"\">[export]</A>");
			out.println("<DIV style='position:relative'>" + 
                                  "<IMG style='position:relative' src='graph1.gif'>" + 
                                  "<IMG style='position:absolute;top:0;left:0' src='/tmp/"+s+"-"+parDate+".gif'>" +
                                  "</DIV><br><br>");
		  
		}

%><FORM>
<TABLE><TR><%
	int n=0;
	for (int i=0; i< f.length; i++)
	{
		if (f[i]!=null)
		{
			String s=f[i][1];
			String ss=f[i][0];
			String sChecked="";
			String pr=f[i].length>=4? f[i][3] : f[i][1];
			
			if (parDataArray!=null) for (int j=0;j<parDataArray.length;j++)
				if (parDataArray[j].equals(s)) sChecked=" checked";
				
			Helper.DEBUG( "property get:" + pr + " is " + pp.getProperty(pr) );

			if (pp.getProperty(pr) == null) 
			{
				ss="<FONT color=#C0C0C0>"+ss+"</FONT>";
				sChecked=sChecked + " disabled";
			};
					   
			out.println("<TD width=20% align=right>"+ss+"<input type=checkbox name=cData value="+s + sChecked+"></TD>\n");
			n++;
		}
		if (n==5 || f[i]==null) {out.println("</TR><TR>"); n=0;}
	}
		
%>
</TR></TABLE>
<SELECT NAME=cDate>
<%
Calendar c=Calendar.getInstance();
DecimalFormat df2=new DecimalFormat("00");
for (int i=0;i<7;i++)
{
	String dt=""+c.get(Calendar.YEAR)+"-"+
		df2.format(c.get(Calendar.MONTH)+1)+"-"+
  		df2.format(c.get(Calendar.DAY_OF_MONTH));
  	String sel= dt.equals(parDate) ? " selected" : "";
	out.println("<OPTION"+sel+">"+dt);
	c.add(Calendar.DAY_OF_MONTH,-1);
}
%>
</SELECT>
<INPUT type=checkbox name="cReload">Reload
<INPUT type=submit value="Get Statistics"></FORM>
</BODY>
</HTML>
