#!/bin/sh
#
# Reschedules suspended tasks from the database
#
# Usage:
#    rescheduleSuspendedTasksDbase.sh 
# Last Updated     : $Author $
# Update Date Time : $Date $
# RCS File Name    : $RCSfile $
# RCS Revision     : $Revision $
# Symbolic name    : $Name $
# State            : $State $
#

. $HOME/etc/setenv.sh

dateStamp=$(date)
echo "$dateStamp : starting reschedule..."

suspTasks=$(sql.sh "select count(*) from TaskQueue where TQQUEUE='suspended'" -N)
drop=1000
wait=30
limit="2000"
sched=$(sql.sh "select count(*) from TaskQueue where TQQUEUE='scheduled'" -N)


while [[ $suspTasks -gt 0 ]] ;
do
    sched=$(sql.sh "select count(*) from TaskQueue where TQQUEUE='scheduled'" -N)
	suspTasks=$(sql.sh "select count(*) from TaskQueue where TQQUEUE='suspended'" -N)
    dateStamp=$(date)
    if [[ $sched -gt $limit ]] ; then
    	echo "$dateStamp : Schedule queue too high ($sched). Waiting $wait seconds." && sleep $wait && continue
    fi
    dateStamp=$(date)
    echo "$dateStamp : Rescheduling $drop / $suspTasks tasks from suspended. Scheduled is $sched / $limit. (bottom number is limit) "
    sql.sh "update TaskQueue set TQQUEUE='unprocessed' where TQQUEUE='suspended' limit $drop" 
    sleep 10
done